//
//  ViewController.m
//  RenderWebViewWithNative
//
//  Created by zxs.zl on 2020/1/10.
//  Copyright © 2020 zxs.zl. All rights reserved.
//

#import "ViewController.h"
#import <WebKit/WebKit.h>

@interface ViewController ()

@property (nonatomic,strong) WKWebView *webView;
@end

@implementation ViewController

- (void)viewDidLoad {
    [super viewDidLoad];
    CGRect frame = self.view.frame;
    frame.origin.y += 44;
    frame.size.height -= 44;
    WKWebViewConfiguration *config = [[WKWebViewConfiguration alloc] init];
    self.webView = [[WKWebView alloc] initWithFrame:frame configuration:config];
    [self.view addSubview:self.webView];
    
    NSString *html = [[NSBundle mainBundle] pathForResource:@"index" ofType:@".html"];
    NSURL *url = [NSURL fileURLWithPath:html];
    [self.webView loadRequest:[NSURLRequest requestWithURL:url]];
    
    dispatch_after(dispatch_time(DISPATCH_TIME_NOW, (int64_t)(3 * NSEC_PER_SEC)), dispatch_get_main_queue(), ^{
        [self startNativeRender_zl_native_node];
    });
}

-(void)startNativeRender_zl_native_node
{
    UIView *view = [self find_zl_native_view];
    UILabel *lbl = [[UILabel alloc] initWithFrame:view.bounds];
    [view addSubview:lbl];
    lbl.alpha = 0;
    [UIView animateWithDuration:3 animations:^{
        lbl.alpha = 0.6;
        lbl.text = @"world";
        lbl.textColor = [UIColor yellowColor];
        lbl.backgroundColor = [UIColor redColor];
        lbl.font = [UIFont systemFontOfSize:49.5];
    }];
}

-(UIView *)get_wkcontentView
{
    for (UIView * v in self.webView.subviews)
    {
        if ([@"WKScrollView" isEqualToString:NSStringFromClass([v class])])
        {
            for (UIView * v2 in v.subviews)
            {
                if ([@"WKContentView" isEqualToString:NSStringFromClass([v2 class])])
                {
                    return v2;
                }
            }
        }
    }
    return nil;
}
-(UIView *)find_zl_native_view
{
    UIView *wkcontentview = [self get_wkcontentView];
    NSMutableArray *arr = [wkcontentview.subviews mutableCopy];
    while (arr.count > 0)
    {
        UIView *comp = arr.firstObject;
        [arr removeObjectAtIndex:0];
        if ([@"WKCompositingView" isEqualToString:NSStringFromClass([comp class])])
        {
            if ([comp.layer.name isEqualToString:@" <div> id='zl_native'"]) {
                return comp;
            }
        }
        
        if (comp.subviews.count > 0)
        {
            [arr addObjectsFromArray:comp.subviews];
        }
    }
    return nil;
}
@end
